
TYPO3.Flow - Bug # 31905

Status: Resolved Priority: Should have
Author: Carsten Bleicker Category: Security
Created: 2011-11-18 Assigned To:
Updated: 2012-05-08 Due date:
PHP Version: 5.3
Has patch: No
Complexity:
Affected Flow version: FLOW3 1.0.0
Subject: getInterceptedRequest is NULL but ACL matches correctly DENY
Description

hi folks,
i had defined an policy for one method wich allows only access if a role exists.
if i call this method without any matching token i will be redirected to the defined WebRedirect.
so anything works fine. but the getInterceptedRequest() of the security contenxt is NULL. it only holds
an interceptRequest if the security matches a second time again. I think there is something wrong with the session?
f.e:
getInterceptedRequest() is NULL if:
    1. init very first visit of my site provides a form wich sends to the controller with policy.
    2. submitting this form
    3. i will get redirected to login
    4. getInterceptedRequest() is NULL
getInterceptedRequest() is filled correctly if:
    1. init very first visit of my site provides a form wich sends to the controller with policy.
    2. submitting this form
    3. i will get redirected to login
    4. getInterceptedRequest() is NULL
    5. going back
    6. submitting again
    7. getInterceptedRequest() is filled correctly

any ideas?

Related issues:
related to TYPO3.Flow - Bug # 31931: AuthenticationController is not working ... Resolved 2011-11-18
duplicated by TYPO3.Flow - Bug # 33311: AuthenticationProviderManager::isAuth... Resolved 2012-01-19

Associated revisions
Revision 4756966d - 2012-05-08 10:43 - Johannes K

[BUGFIX] Authentication: context now reliably stores the intercepted request

On authentication the original intercepted request was not stored,
when there was no current session. The session now gets automatically
initialized via @FLOW3\Session(autoStart=true).

Change-Id: Icc3bc6d1338061459945e97bb1bc8e8981cfc18c
Fixes: #31905
Releases: 1.1

2015-08-03 1/3



Revision 900a207a - 2012-05-08 10:43 - Robert Lemke

[TASK] Improve security isolation in functional tests

This change makes sure that also the intercepted request
(if any) is cleared on clearContext() and renames the
authentication provider configured for the Testing
context from "DefaultProvider" to "TestingProvider".

Change-Id: Ib8553f5453f5d2c5b63ffc16f4382cfb80da686a
Related: #31905
Releases: 1.1

History
#1 - 2011-11-18 13:21 - Carsten Bleicker

On first Init there is no cookie named FLOW3.

so the Bootstrap->initializeSession() tries to resume the session.
But because of missing $_COOKIE[session_name()] its not resumed.
This results the getInterceptedRequest() with NULL.

public function resume() {
    if ($this->started === FALSE && isset($_COOKIE[session_name()])) {
        $this->startOrResume();
    }
}

appendix:
this wording of methods confusing me a little bit.
resume calls a startOrResume?
if i call a resume i expect to resume and not start something.
why does the bootstrap not call startOrResume and this one decides between start or resume?
or do i expect this wrong?

#2 - 2011-11-22 12:48 - Karsten Dambekalns
- Target version changed from 1.0.1 to 1.0.2

#3 - 2011-12-22 08:51 - Karsten Dambekalns
- Target version changed from 1.0.2 to 1.0.3

#4 - 2011-12-29 15:42 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7635

#5 - 2012-02-02 18:33 - Gerrit Code Review
Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7635

#6 - 2012-03-07 18:52 - Karsten Dambekalns
- Target version changed from 1.0.3 to 1.0.4

#7 - 2012-04-18 22:49 - Karsten Dambekalns
- Target version changed from 1.0.4 to 1.0.5

#8 - 2012-05-08 10:43 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7635

#9 - 2012-05-08 10:43 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7635

#10 - 2012-05-08 14:38 - Johannes K
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:4756966d29055e09150648fd85f78f87204c6026.
